<template>
  <form class="login" @submit.prevent="tryLogin" novalidate>
    <!--novalidate = disable browser validation -->
    <h2 class="login-title" tabindex="-1">Login</h2>
    <FormField
      id="email"
      inputType="email"
      v-model.trim="email"
      :error="emailError"
      :required="true"
    ></FormField>
    <FormField
      id="password"
      inputType="password"
      v-model.trim="password"
      :error="passwordError"
      :required="true"
    ></FormField>
    <div class="buttons">
      <ActionButton type="submit">Login</ActionButton>
    </div>
    <span class="serverError" v-if="serverError">{{ serverError }}</span>
  </form>
</template>

<script>
import FormField from "../molecules/FormField.vue";
import ActionButton from "../atoms/ActionButton.vue";
import store from "../../store/auth.js";

const emailRegex = RegExp(
  /^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/
);

export default {
  components: { FormField, ActionButton },
  data() {
    return {
      email: null,
      password: null,
      submitted: false,
      serverError: null,
    };
  },
  computed: {
    emailError() {
      let error;
      if (!this.submitted) {
        error = null;
      } else if (!this.email) {
        error = "email is a required field and was not provided";
      } else if (!emailRegex.test(this.email)) {
        error =
          "the email provided does not follow the pattern name@domain.extension";
      }
      return error;
    },
    passwordError() {
      let error;
      if (!this.submitted) {
        error = null;
      } else if (!this.password) {
        error = "password is a required field and was not provided";
      }
      return error;
    },
  },
  methods: {
    async tryLogin() {
      this.serverError = null;
      this.submitted = true;
      store.commit("general/setLoading", true);
      if (this.emailError == null && this.passwordError == null) {
        try {
          const result = await store.dispatch("auth/login", {
            email: this.email,
            password: this.password,
          });
          if (result.status === 200) {
            this.$router.push({ name: "home" });
          }
        } catch (error) {
          console.log(error);
          if (error.code === "ERR_NETWORK") {
            this.serverError = "Service temporarily unavailable";
          } else if (error.response.status === 401) {
            this.serverError = "Email and/or password is wrong";
          } else {
            this.serverError = error;
          }
        }
      }
      store.commit("general/setLoading", false);
    },
  },
};
</script>

<style lang="scss">
.login-title {
  align-self: center;
  color: #09639b;
}
.buttons {
  display: flex;
  flex-direction: row;

  justify-content: center;
  align-items: center;
  margin: 0.5rem;
}
.login {
  display: flex;
  flex-direction: column;
  background-color: white;
  border: solid 0.1rem #09639b;
  margin: 0 20%;
  border-radius: 0.5rem;
}
.serverError {
  color: red;
  text-align: center;
}
</style>
